Index: /trunk/admin/admin.php
===================================================================
--- /trunk/admin/admin.php	(revision 20)
+++ /trunk/admin/admin.php	(revision 21)
@@ -26,35 +26,89 @@
 //--------------------------------------- validating page and creation of title
 $page_valide = false;
+$title = '';
 switch ( $_GET['page'] )
 {
  case 'user_add':
-   $titre = $lang['title_add'];           $page_valide = true; break;
+   $title = $lang['title_add'];           $page_valide = true; break;
  case 'user_list':
-   $titre = $lang['title_liste_users'];   $page_valide = true; break;
+   $title = $lang['title_liste_users'];   $page_valide = true; break;
  case 'user_modify':
-   $titre = $lang['title_modify'];        $page_valide = true; break;
+   $title = $lang['title_modify'];        $page_valide = true; break;
+ case 'user_perm':
+   if ( !is_numeric( $_GET['user_id'] ) ) $_GET['user_id'] = -1;
+   $query = 'SELECT status,username';
+   $query.= ' FROM '.PREFIX_TABLE.'users';
+   $query.= ' WHERE id = '.$_GET['user_id'];
+   $query.= ';';
+   $result = mysql_query( $query );
+   if ( mysql_num_rows( $result ) > 0 )
+   {
+     $row = mysql_fetch_array( $result );
+     $page['user_status']   = $row['status'];
+     if ( $row['username'] == 'guest' ) $row['username'] = $lang['guest'];
+     $page['user_username'] = $row['username'];
+     $page_valide = true;
+     $title = $lang['title_user_perm'].' "'.$page['user_username'].'"';
+   }
+   else
+   {
+     $page_valide = false;
+   }
+   break;
+ case 'group_list' :
+   $title = $lang['title_groups'];        $page_valide = true; break;
+ case 'group_perm' :
+   if ( !is_numeric( $_GET['group_id'] ) ) $_GET['group_id'] = -1;
+   $query = 'SELECT name';
+   $query.= ' FROM '.PREFIX_TABLE.'groups';
+   $query.= ' WHERE id = '.$_GET['group_id'];
+   $query.= ';';
+   $result = mysql_query( $query );
+   if ( mysql_num_rows( $result ) > 0 )
+   {
+     $row = mysql_fetch_array( $result );
+     $title = $lang['title_group_perm'].' "'.$row['name'].'"';
+     $page_valide = true;
+   }
+   else
+   {
+     $page_valide = false;
+   }
+   break;
  case 'historique':
-   $titre = $lang['title_history'];       $page_valide = true; break;
+   $title = $lang['title_history'];       $page_valide = true; break;
  case 'update':
-   $titre = $lang['title_update'];        $page_valide = true; break;
+   $title = $lang['title_update'];        $page_valide = true; break;
  case 'configuration':
-   $titre = $lang['title_configuration']; $page_valide = true; break;
+   $title = $lang['title_configuration']; $page_valide = true; break;
  case 'manuel':
-   $titre = $lang['title_instructions'];  $page_valide = true; break;
- case 'perm':
-   $titre = $lang['title_permissions'];   $page_valide = true; break;
- case 'cat':
-   $titre = $lang['title_categories'];    $page_valide = true; break;
- case 'edit_cat':
-   $titre = $lang['title_edit_cat'];      $page_valide = true; break;
+   $title = $lang['title_instructions'];  $page_valide = true; break;
+ case 'cat_perm':
+   $title = $lang['title_cat_perm'];
+   if ( isset( $_GET['cat_id'] ) )
+   {
+     check_cat_id( $_GET['cat_id'] );
+     if ( isset( $page['cat'] ) and is_numeric( $page['cat'] ) )
+     {
+       $result = get_cat_info( $page['cat'] );
+       $name = get_cat_display_name( $result['name'],' &gt; ', '' );
+       $title.= ' "'.$name.'"';
+     }
+   }
+   $page_valide = true;
+   break;
+ case 'cat_list':
+   $title = $lang['title_categories'];    $page_valide = true; break;
+ case 'cat_modify':
+   $title = $lang['title_edit_cat'];      $page_valide = true; break;
  case 'infos_images':
-   $titre = $lang['title_info_images'];   $page_valide = true; break;
+   $title = $lang['title_info_images'];   $page_valide = true; break;
  case 'waiting':
-   $titre = $lang['title_waiting'];       $page_valide = true; break;
+   $title = $lang['title_waiting'];       $page_valide = true; break;
  case 'thumbnail':
-   $titre = $lang['title_thumbnails'];
+   $title = $lang['title_thumbnails'];
    if ( isset( $_GET['dir'] ) )
    {
-     $titre.= ' '.$lang['title_thumbnails_2'].' <span style="color:#006699;">';
+     $title.= ' '.$lang['title_thumbnails_2'].' <span style="color:#006699;">';
      // $_GET['dir'] contient :
      // ../galleries/vieux_lyon ou
@@ -62,17 +116,18 @@
      // ../galleries/vieux_lyon/visite/truc ...
      $dir = explode( "/", $_GET['dir'] );
-     $titre.= $dir[2];
+     $title.= $dir[2];
      for ( $i = 3; $i < sizeof( $dir ) - 1; $i++ )
      {
-       $titre.= ' &gt; '.$dir[$i];
+       $title.= ' &gt; '.$dir[$i];
      }
-     $titre.= "</span>";
+     $title.= "</span>";
    }
    $page_valide = true;
    break;
  default:
-   $titre = $lang['title_default']; break;
-}
-$vtp->setGlobalVar( $handle, 'title', $titre );
+   $title = $lang['title_default']; break;
+}
+if ( $title == '' ) $title = $lang['title_default'];
+$vtp->setGlobalVar( $handle, 'title', $title );
 //--------------------------------------------------------------------- summary
 $link_start = './admin.php?page=';
@@ -88,5 +143,5 @@
 $vtp->setVar( $handle, 'summary.indent', '' );
 $vtp->setVar( $handle, 'summary.link',
-              add_session_id( $link_start.'liste_users' ) );
+              add_session_id( $link_start.'user_list' ) );
 $vtp->setVar( $handle, 'summary.name', $lang['menu_users'] );
 $vtp->closeSession( $handle, 'summary' );
@@ -105,8 +160,15 @@
 $vtp->setVar( $handle, 'summary.name', $lang['menu_add_user'] );
 $vtp->closeSession( $handle, 'summary' );
+// groups
+$vtp->addSession( $handle, 'summary' );
+$vtp->setVar( $handle, 'summary.indent', '' );
+$vtp->setVar( $handle, 'summary.link',
+              add_session_id( $link_start.'group_list' ) );
+$vtp->setVar( $handle, 'summary.name', $lang['menu_groups'] );
+$vtp->closeSession( $handle, 'summary' );
 // categories
 $vtp->addSession( $handle, 'summary' );
 $vtp->setVar( $handle, 'summary.indent', '' );
-$vtp->setVar( $handle, 'summary.link', add_session_id( $link_start.'cat' ) );
+$vtp->setVar( $handle, 'summary.link',add_session_id( $link_start.'cat_list'));
 $vtp->setVar( $handle, 'summary.name', $lang['menu_categories'] );
 $vtp->closeSession( $handle, 'summary' );
Index: /trunk/admin/cat_list.php
===================================================================
--- /trunk/admin/cat_list.php	(revision 21)
+++ /trunk/admin/cat_list.php	(revision 21)
@@ -0,0 +1,293 @@
+<?php
+/***************************************************************************
+ *                                  cat.php                                *
+ *                            -------------------                          *
+ *   application          : PhpWebGallery 1.3                              *
+ *   website              : http://www.phpwebgallery.net                   *
+ *   author               : Pierrick LE GALL <pierrick@z0rglub.com>        *
+ *                                                                         *
+ ***************************************************************************/
+
+/***************************************************************************
+ *                                                                         *
+ *   This program is free software; you can redistribute it and/or modify  *
+ *   it under the terms of the GNU General Public License as published by  *
+ *   the Free Software Foundation;                                         *
+ *                                                                         *
+ ***************************************************************************/
+include_once( './include/isadmin.inc.php' );
+//----------------------------------------------------- template initialization
+$sub = $vtp->Open( '../template/'.$user['template'].'/admin/cat_list.vtp' );
+// language
+$vtp->setGlobalVar( $sub, 'cat_edit',        $lang['cat_edit'] );
+$vtp->setGlobalVar( $sub, 'cat_up',          $lang['cat_up'] );
+$vtp->setGlobalVar( $sub, 'cat_down',        $lang['cat_down'] );
+$vtp->setGlobalVar( $sub, 'cat_image_info',  $lang['cat_image_info'] );
+$vtp->setGlobalVar( $sub, 'cat_permission',  $lang['cat_permission'] );
+$vtp->setGlobalVar( $sub, 'cat_update',      $lang['cat_update'] );
+//---------------------------------------------------------------  rank updates
+if ( isset( $_GET['up'] ) && is_numeric( $_GET['up'] ) )
+{
+  // 1. searching level (id_uppercat)
+  //    and rank of the category to move
+  $query = 'SELECT id_uppercat,rank';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= ' WHERE id = '.$_GET['up'];
+  $query.= ';';
+  $row = mysql_fetch_array( mysql_query( $query ) );
+  $level = $row['id_uppercat'];
+  $rank  = $row['rank'];
+  // 2. searching the id and the rank of the category
+  //    just above at the same level
+  $query = 'SELECT id,rank';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= ' WHERE rank < '.$rank;
+  if ( $level == '' )
+  {
+    $query.= ' AND id_uppercat IS NULL';
+  }
+  else
+  {
+    $query.= ' AND id_uppercat = '.$level;
+  }
+  $query.= ' ORDER BY rank DESC';
+  $query.= ' LIMIT 0,1';
+  $query.= ';';
+  $row = mysql_fetch_array( mysql_query( $query ) );
+  $new_rank     = $row['rank'];
+  $replaced_cat = $row['id'];
+  // 3. exchanging ranks between the two categories
+  $query = 'UPDATE '.PREFIX_TABLE.'categories';
+  $query.= ' SET rank = '.$new_rank;
+  $query.= ' WHERE id = '.$_GET['up'];
+  $query.= ';';
+  mysql_query( $query );
+  $query = 'UPDATE '.PREFIX_TABLE.'categories';
+  $query.= ' SET rank = '.$rank;
+  $query.= ' WHERE id = '.$replaced_cat;
+  $query.= ';';
+  mysql_query( $query );
+}
+if ( isset( $_GET['down'] ) && is_numeric( $_GET['down'] ) )
+{
+  // 1. searching level (id_uppercat)
+  //    and rank of the category to move
+  $query = 'SELECT id_uppercat,rank';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= ' WHERE id = '.$_GET['down'];
+  $query.= ';';
+  $row = mysql_fetch_array( mysql_query( $query ) );
+  $level = $row['id_uppercat'];
+  $rank  = $row['rank'];
+  // 2. searching the id and the rank of the category
+  //    just below at the same level
+  $query = 'SELECT id,rank';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= ' WHERE rank > '.$rank;
+  if ( $level == '' )
+  {
+    $query.= ' AND id_uppercat is null';
+  }
+  else
+  {
+    $query.= ' AND id_uppercat = '.$level;
+  }
+  $query.= ' ORDER BY rank ASC';
+  $query.= ' LIMIT 0,1';
+  $query.= ';';
+  $row = mysql_fetch_array( mysql_query( $query ) );
+  $new_rank     = $row['rank'];
+  $replaced_cat = $row['id'];
+  // 3. exchanging ranks between the two categories
+  $query = 'UPDATE '.PREFIX_TABLE.'categories';
+  $query.= ' SET rank = '.$new_rank;
+  $query.= ' WHERE id = '.$_GET['down'];
+  $query.= ';';
+  mysql_query( $query );
+  $query = 'UPDATE '.PREFIX_TABLE.'categories';
+  $query.= ' SET rank = '.$rank;
+  $query.= ' WHERE id = '.$replaced_cat;
+  $query.= ';';
+  mysql_query( $query );
+}
+//------------------------------------------------------------------ reordering
+function ordering( $id_uppercat )
+{
+  $rank = 1;
+		
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  if ( !is_numeric( $id_uppercat ) )
+  {
+    $query.= ' WHERE id_uppercat IS NULL';
+  }
+  else
+  {
+    $query.= ' WHERE id_uppercat = '.$id_uppercat;
+  }
+  $query.= ' ORDER BY rank ASC, dir ASC';
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    $query = 'UPDATE '.PREFIX_TABLE.'categories';
+    $query.= ' SET rank = '.$rank;
+    $query.= ' WHERE id = '.$row['id'];
+    $query.= ';';
+    mysql_query( $query );
+    $rank++;
+    ordering( $row['id'] );
+  }
+}
+	
+ordering( 'NULL' );
+//----------------------------------------------------affichage de la page
+function display_cat_manager( $id_uppercat, $indent,
+                              $uppercat_visible, $level )
+{
+  global $lang,$conf,$sub,$vtp;
+		
+  // searching the min_rank and the max_rank of the category
+  $query = 'SELECT MIN(rank) AS min, MAX(rank) AS max';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  if ( !is_numeric( $id_uppercat ) )
+  {
+    $query.= ' WHERE id_uppercat IS NULL';
+  }
+  else
+  {
+    $query.= ' WHERE id_uppercat = '.$id_uppercat;
+  }
+  $query.= ';';
+  $result = mysql_query( $query );
+  $row    = mysql_fetch_array( $result );
+  $min_rank = $row['min'];
+  $max_rank = $row['max'];
+		
+  // will we use <th> or <td> lines ?
+  $td    = 'td';
+  $class = '';
+  if ( $level > 0 )
+  {
+    $class = 'row'.$level;
+  }
+  else
+  {
+    $td = 'th';
+  }
+		
+  $query = 'SELECT id,name,dir,nb_images,status,rank,site_id,visible';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  if ( !is_numeric( $id_uppercat ) )
+  {
+    $query.= ' WHERE id_uppercat IS NULL';
+  }
+  else
+  {
+    $query.= ' WHERE id_uppercat = '.$id_uppercat;
+  }
+  $query.= ' ORDER BY rank ASC';
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    $subcat_visible = true;
+
+    $vtp->addSession( $sub, 'cat' );
+    $vtp->setVar( $sub, 'cat.td', $td );
+    $vtp->setVar( $sub, 'cat.class', $class );
+    $vtp->setVar( $sub, 'cat.indent', $indent );
+    if ( $row['name'] == '' )
+    {
+      $name = str_replace( '_', ' ', $row['dir'] );
+    }
+    else
+    {
+      $name = $row['name'];
+    }
+    $vtp->setVar( $sub, 'cat.name', $name );
+    $vtp->setVar( $sub, 'cat.dir', $row['dir'] );
+    if ( $row['visible'] == 'false' or !$uppercat_visible )
+    {
+      $subcat_visible = false;
+      $vtp->setVar( $sub, 'cat.invisible', $lang['cat_invisible'] );
+    }
+    if ( $row['status'] == 'private' )
+    {
+      $vtp->setVar( $sub, 'cat.private', $lang['private'] );
+    }
+    $vtp->setVar( $sub, 'cat.nb_picture', $row['nb_images'] );
+    $url = add_session_id( './admin.php?page=cat_modify&amp;cat='.$row['id'] );
+    $vtp->setVar( $sub, 'cat.edit_url', $url );
+    if ( $row['rank'] != $min_rank )
+    {
+      $vtp->addSession( $sub, 'up' );
+      $url = add_session_id( './admin.php?page=cat&amp;up='.$row['id'] );
+      $vtp->setVar( $sub, 'up.up_url', $url );
+      $vtp->closeSession( $sub, 'up' );
+    }
+    else
+    {
+      $vtp->addSession( $sub, 'no_up' );
+      $vtp->closeSession( $sub, 'no_up' );
+    }
+    if ( $row['rank'] != $max_rank )
+    {
+      $vtp->addSession( $sub, 'down' );
+      $url = add_session_id( './admin.php?page=cat&amp;down='.$row['id'] );
+      $vtp->setVar( $sub, 'down.down_url', $url );
+      $vtp->closeSession( $sub, 'down' );
+    }
+    else
+    {
+      $vtp->addSession( $sub, 'no_down' );
+      $vtp->closeSession( $sub, 'no_down' );
+    }
+    if ( $row['nb_images'] > 0 )
+    {
+      $vtp->addSession( $sub, 'image_info' );
+      $url = add_session_id( './admin.php?page=infos_images&amp;cat_id='
+                             .$row['id'] );
+      $vtp->setVar( $sub, 'image_info.image_info_url', $url );
+      $vtp->closeSession( $sub, 'image_info' );
+    }
+    else
+    {
+      $vtp->addSession( $sub, 'no_image_info' );
+      $vtp->closeSession( $sub, 'no_image_info' );
+    }
+    if ( $row['status'] == 'private' )
+    {
+      $vtp->addSession( $sub, 'permission' );
+      $url=add_session_id('./admin.php?page=cat_perm&amp;cat_id='.$row['id']);
+      $vtp->setVar( $sub, 'permission.url', $url );
+      $vtp->closeSession( $sub, 'permission' );
+    }
+    else
+    {
+      $vtp->addSession( $sub, 'no_permission' );
+      $vtp->closeSession( $sub, 'no_permission' );
+    }
+    if ( $row['site_id'] == 1 )
+    {
+      $vtp->addSession( $sub, 'update' );
+      $url = add_session_id('./admin.php?page=update&amp;update='.$row['id']);
+      $vtp->setVar( $sub, 'update.update_url', $url );
+      $vtp->closeSession( $sub, 'update' );
+    }
+    else
+    {
+      $vtp->addSession( $sub, 'no_update' );
+      $vtp->closeSession( $sub, 'no_update' );
+    }
+
+    $vtp->closeSession( $sub, 'cat' );
+
+    display_cat_manager( $row['id'], $indent.str_repeat( '&nbsp', 4 ),
+                         $subcat_visible, $level + 1 );
+  }
+}
+display_cat_manager( 'NULL', str_repeat( '&nbsp', 4 ), true, 0 );
+//----------------------------------------------------------- sending html code
+$vtp->Parse( $handle , 'sub', $sub );
+?>
Index: /trunk/admin/cat_modify.php
===================================================================
--- /trunk/admin/cat_modify.php	(revision 21)
+++ /trunk/admin/cat_modify.php	(revision 21)
@@ -0,0 +1,153 @@
+<?php
+/***************************************************************************
+ *                               cat_modify.php                            *
+ *                            -------------------                          *
+ *   application          : PhpWebGallery 1.3                              *
+ *   author               : Pierrick LE GALL <pierrick@z0rglub.com>        *
+ *                                                                         *
+ ***************************************************************************/
+
+/***************************************************************************
+ *                                                                         *
+ *   This program is free software; you can redistribute it and/or modify  *
+ *   it under the terms of the GNU General Public License as published by  *
+ *   the Free Software Foundation;                                         *
+ *                                                                         *
+ ***************************************************************************/
+
+include_once( './include/isadmin.inc.php' );
+//----------------------------------------------------- template initialization
+$sub = $vtp->Open( '../template/'.$user['template'].'/admin/cat_modify.vtp' );
+$tpl = array( 'remote_site','editcat_confirm','editcat_back','editcat_title1',
+              'editcat_name','editcat_comment','editcat_status',
+              'editcat_visible','editcat_status_info', 'submit' );
+templatize_array( $tpl, 'lang', $sub );
+//---------------------------------------------------------------- verification
+if ( !is_numeric( $_GET['cat'] ) )
+{
+  $_GET['cat'] = '-1';
+}
+//--------------------------------------------------------- form criteria check
+if ( isset( $_POST['submit'] ) )
+{
+  // if new status is different from previous one, deletion of all related
+  // links for access rights
+  $query = 'SELECT status';
+  $query.= ' FROM '.PREFIX_TABLE.'categories';
+  $query.= ' WHERE id = '.$_GET['cat'];
+  $query.= ';';
+  $row = mysql_fetch_array( mysql_query( $query ) );
+
+  if ( $_POST['status'] != $row['status'] )
+  {
+    // deletion of all access for groups concerning this category
+    $query = 'DELETE';
+    $query.= ' FROM '.PREFIX_TABLE.'group_access';
+    $query.= ' WHERE cat_id = '.$_GET['cat'];
+    mysql_query( $query );
+    // deletion of all access for users concerning this category
+    $query = 'DELETE';
+    $query.= ' FROM '.PREFIX_TABLE.'user_access';
+    $query.= ' WHERE cat_id = '.$_GET['cat'];
+    mysql_query( $query );
+  }
+  
+  $query = 'UPDATE '.PREFIX_TABLE.'categories';
+  if ( $_POST['name'] == '' )
+  {
+    $query.= ' SET name = NULL';
+  }
+  else
+  {
+    $query.= " SET name = '".htmlentities( $_POST['name'], ENT_QUOTES)."'";
+  }
+  if ( $_POST['comment'] == '' )
+  {
+    $query.= ', comment = NULL';
+  }
+  else
+  {
+    $query.= ", comment = '".htmlentities( $_POST['comment'], ENT_QUOTES )."'";
+  }
+  $query.= ", status = '".$_POST['status']."'";
+  $query.= ", visible = '".$_POST['visible']."'";
+  $query.= " WHERE id = '".$_GET['cat']."'";
+  $query.= ';';
+  mysql_query( $query );
+
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'users';
+  $query.= " WHERE username != '".$conf['webmaster']."'";
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array ( $result ) )
+  {
+    check_favorites( $row['id'] );
+  }
+  $vtp->addSession( $sub, 'confirmation' );
+  $url = add_session_id( './admin.php?page=cat_list' );
+  $vtp->setVar( $sub, 'confirmation.back_url', $url );
+  $vtp->closeSession( $sub, 'confirmation' );
+}
+//------------------------------------------------------------------------ form
+$form_action = './admin.php?page=cat_modify&amp;cat='.$_GET['cat'];
+$vtp->setVar( $sub, 'form_action', add_session_id( $form_action ) );
+
+$query = 'SELECT a.id,name,dir,status,comment';
+$query.= ',id_uppercat,site_id,galleries_url,visible';
+$query.= ' FROM '.PREFIX_TABLE.'categories as a, '.PREFIX_TABLE.'sites as b';
+$query.= ' WHERE a.id = '.$_GET['cat'];
+$query.= ' AND a.site_id = b.id';
+$query.= ';';
+$row = mysql_fetch_array( mysql_query( $query ) );
+$result = get_cat_info( $row['id'] );
+// cat name
+$cat_name = get_cat_display_name( $result['name'], ' - ', '' );
+$vtp->setVar( $sub, 'cat:name', $cat_name );
+// cat dir
+$vtp->setVar( $sub, 'cat:dir', $row['dir'] );
+// remote site ?
+if ( $row['site_id'] != 1 )
+{
+  $vtp->addSession( $sub, 'server' );
+  $vtp->setVar( $sub, 'server.url', $row['galleries_url'] );
+  $vtp->closeSession( $sub, 'server' );
+}
+$vtp->setVar( $sub, 'name',    $row['name'] );
+$vtp->setVar( $sub, 'comment', $row['comment'] );
+// status : public, private...
+$options = get_enums( PREFIX_TABLE.'categories', 'status' );
+foreach ( $options as $option  ) {
+  $vtp->addSession( $sub, 'status_option' );
+  $vtp->setVar( $sub, 'status_option.option', $lang[$option] );
+  $vtp->setVar( $sub, 'status_option.value', $option );
+  if ( $option == $row['status'] )
+  {
+    $vtp->setVar( $sub, 'status_option.checked', ' checked="checked"' );  
+  }
+  $vtp->closeSession( $sub, 'status_option' );
+}
+// visible : true or false
+$vtp->addSession( $sub, 'visible_option' );
+$vtp->setVar( $sub, 'visible_option.value', 'true' );
+$vtp->setVar( $sub, 'visible_option.option', $lang['yes'] );
+$checked = '';
+if ( $row['visible'] == 'true' )
+{
+  $checked = ' checked="checked"';
+}
+$vtp->setVar( $sub, 'visible_option.checked', $checked );
+$vtp->closeSession( $sub, 'visible_option' );
+$vtp->addSession( $sub, 'visible_option' );
+$vtp->setVar( $sub, 'visible_option.value', 'false' );
+$vtp->setVar( $sub, 'visible_option.option', $lang['no'] );
+$checked = '';
+if ( $row['visible'] == 'false' )
+{
+  $checked = ' checked="checked"';
+}
+$vtp->setVar( $sub, 'visible_option.checked', $checked );
+$vtp->closeSession( $sub, 'visible_option' );
+//----------------------------------------------------------- sending html code
+$vtp->Parse( $handle , 'sub', $sub );
+?>
Index: /trunk/admin/cat_perm.php
===================================================================
--- /trunk/admin/cat_perm.php	(revision 21)
+++ /trunk/admin/cat_perm.php	(revision 21)
@@ -0,0 +1,210 @@
+<?php
+/***************************************************************************
+ *                               cat_perm.php                              *
+ *                            ------------------                           *
+ *   application          : PhpWebGallery 1.3                              *
+ *   author               : Pierrick LE GALL <pierrick@z0rglub.com>        *
+ *                                                                         *
+ ***************************************************************************/
+
+/***************************************************************************
+ *                                                                         *
+ *   This program is free software; you can redistribute it and/or modify  *
+ *   it under the terms of the GNU General Public License as published by  *
+ *   the Free Software Foundation;                                         *
+ *                                                                         *
+ ***************************************************************************/
+include_once( './include/isadmin.inc.php' );
+//----------------------------------------------------- template initialization
+$sub = $vtp->Open( '../template/'.$user['template'].'/admin/cat_perm.vtp' );
+$error = array();
+$tpl = array( 'permuser_authorized','permuser_forbidden','menu_groups',
+              'submit','menu_users','permuser_parent_forbidden' );
+templatize_array( $tpl, 'lang', $sub );
+//-------------------------------------------------------------- category infos
+if ( isset( $_GET['cat_id'] ) )
+{
+  check_cat_id( $_GET['cat_id'] );
+  if ( isset( $page['cat'] ) and is_numeric( $page['cat'] ) )
+  {
+    $result = get_cat_info( $page['cat'] );
+    $page['cat_name']    = $result['name'];
+    $page['id_uppercat'] = $result['id_uppercat'];
+  }
+}
+//---------------------------------------------------------- permission updates
+if ( isset( $_POST['submit'] ) )
+{
+  // groups access update
+  $query = 'DELETE';
+  $query.= ' FROM '.PREFIX_TABLE.'group_access';
+  $query.= ' WHERE cat_id = '.$page['cat'];
+  $query.= ';';
+  mysql_query( $query );
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'groups';
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    $radioname = 'groupaccess-'.$row['id'];
+    if ( $_POST[$radioname] == 0 )
+    {
+      $query = 'INSERT INTO '.PREFIX_TABLE.'group_access';
+      $query.= ' (cat_id,group_id) VALUES';
+      $query.= ' ('.$page['cat'].','.$row['id'].')';
+      $query.= ';';
+      mysql_query( $query );
+    }
+  }
+  // users access update
+  $query = 'DELETE';
+  $query.= ' FROM '.PREFIX_TABLE.'user_access';
+  $query.= ' WHERE cat_id = '.$page['cat'];
+  $query.= ';';
+  mysql_query( $query );
+  $query = 'SELECT id';
+  $query.= ' FROM '.PREFIX_TABLE.'users';
+  $query.= ';';
+  $result = mysql_query( $query );
+  while ( $row = mysql_fetch_array( $result ) )
+  {
+    $radioname = 'useraccess-'.$row['id'];
+    if ( $_POST[$radioname] == 0 )
+    {
+      $query = 'INSERT INTO '.PREFIX_TABLE.'user_access';
+      $query.= ' (cat_id,user_id) VALUES';
+      $query.= ' ('.$page['cat'].','.$row['id'].')';
+      $query.= ';';
+      mysql_query( $query );
+    }
+    check_favorites( $row['id'] );
+  }
+  // echo "<div class=\"info\">".$lang['permuser_info_message']." [ <a href=\"".add_session_id_to_url( "./admin.php?page=cat" )."\">".$lang['editcat_back']."</a> ]</div>";
+}
+//---------------------------------------------------------------------- groups
+$query = 'SELECT id,name';
+$query.= ' FROM '.PREFIX_TABLE.'groups';
+$query. ';';
+$result = mysql_query( $query );
+if ( mysql_num_rows( $result ) > 0 )
+{
+  $vtp->addSession( $sub, 'groups' );
+  // creating an array with all authorized groups for this category
+  $query = 'SELECT group_id';
+  $query.= ' FROM '.PREFIX_TABLE.'group_access';
+  $query.= ' WHERE cat_id = '.$_GET['cat_id'];
+  $query.= ';';
+  $subresult = mysql_query( $query );
+  $authorized_groups = array();
+  while ( $subrow = mysql_fetch_array( $subresult ) )
+  {
+    array_push( $authorized_groups, $subrow['group_id'] );
+  }
+  // displaying each group
+  while( $row = mysql_fetch_array( $result ) )
+  {
+    $vtp->addSession( $sub, 'group' );
+    if ( in_array( $row['id'], $authorized_groups ) )
+    {
+      $vtp->setVar( $sub, 'group.color', 'green' );
+      $vtp->setVar( $sub, 'group.authorized_checked', ' checked="checked"' );
+    }
+    else
+    {
+      $vtp->setVar( $sub, 'group.color', 'red' );
+      $vtp->setVar( $sub, 'group.forbidden_checked', ' checked="checked"' );
+    }
+    $vtp->setVar( $sub, 'group.groupname', $row['name'] );
+    $vtp->setVar( $sub, 'group.id', $row['id'] );
+    $vtp->closeSession( $sub, 'group' );
+  }
+  $vtp->closeSession( $sub, 'groups' );
+}
+//----------------------------------------------------------------------- users
+$query = 'SELECT id,username,status';
+$query.= ' FROM '.PREFIX_TABLE.'users';
+$query.= " WHERE username != '".$conf['webmaster']."'";
+$query.= ';';
+$result = mysql_query( $query );
+while ( $row = mysql_fetch_array( $result ) )
+{
+  $vtp->addSession( $sub, 'user' );
+  $vtp->setVar( $sub, 'user.id', $row['id'] );
+  $url = add_session_id( './admin.php?page=user_perm&amp;user_id='.$row['id']);
+  $vtp->setVar( $sub, 'user.user_perm_link', $url);
+  if ( $row['username'] == 'guest' )
+  {
+    $row['username'] = $lang['guest'];
+  }
+  $vtp->setVar( $sub, 'user.username', $row['username'] );
+
+  // for color of user : (red means access forbidden, green authorized) we
+  // ask all forbidden categories, including the groups rights
+  $restrictions = get_restrictions( $row['id'], $row['status'], false );
+  $is_user_allowed = is_user_allowed( $page['cat'], $restrictions );
+  if ( $is_user_allowed == 0 )
+  {
+    $vtp->setVar( $sub, 'user.color', 'green' );
+  }
+  else
+  {
+    $vtp->setVar( $sub, 'user.color', 'red' );
+  }
+  // for permission update button, we only ask forbidden categories for the
+  // user, not taking into account the groups the user belongs to
+  $restrictions = get_restrictions( $row['id'], $row['status'], false, false );
+  $is_user_allowed = is_user_allowed( $page['cat'], $restrictions );
+  if ( $is_user_allowed == 2 )
+  {
+    $vtp->addSession( $sub, 'parent_forbidden' );
+    $url = './admin.php?page=cat_perm&amp;cat_id='.$page['id_uppercat'];
+    $vtp->setVar( $sub, 'parent_forbidden.url', add_session_id( $url ) );
+    $vtp->closeSession( $sub, 'parent_forbidden' );
+  }
+  if ( $is_user_allowed == 0 )
+  {
+    $vtp->setVar( $sub, 'user.authorized_checked', ' checked="checked"' );
+  }
+  else
+  {
+    $vtp->setVar( $sub, 'user.forbidden_checked', ' checked="checked"' );
+  }
+  // user's group(s)
+  $query = 'SELECT g.name as groupname, g.id as groupid';
+  $query.= ' FROM '.PREFIX_TABLE.'groups as g';
+  $query.= ', '.PREFIX_TABLE.'user_group as ug';
+  $query.= ' WHERE ug.group_id = g.id';
+  $query.= ' AND ug.user_id = '.$row['id'];
+  $query.= ';';
+  $subresult = mysql_query( $query );
+  if ( mysql_num_rows( $subresult ) > 0 )
+  {
+    $vtp->addSession( $sub, 'usergroups' );
+    $i = 0;
+    while( $subrow = mysql_fetch_array( $subresult ) )
+    {
+      $vtp->addSession( $sub, 'usergroup' );
+      if ( in_array( $subrow['groupid'], $authorized_groups ) )
+      {
+        $vtp->setVar( $sub, 'usergroup.color', 'green' );
+      }
+      else
+      {
+        $vtp->setVar( $sub, 'usergroup.color', 'red' );
+      }
+      $vtp->setVar( $sub, 'usergroup.name', $subrow['groupname'] );
+      if ( $i < mysql_num_rows( $subresult ) - 1 )
+      {
+        $vtp->setVar( $sub, 'usergroup.separation', ',' );
+      }
+      $vtp->closeSession( $sub, 'usergroup' );
+      $i++;
+    }
+    $vtp->closeSession( $sub, 'usergroups' );
+  }
+  $vtp->closeSession( $sub, 'user' );
+}
+//----------------------------------------------------------- sending html code
+$vtp->Parse( $handle , 'sub', $sub );
+?>
